|
This file is 2.1 rom, maybe can fsck & reformat system...but i haven't use or try....please read it first...- #!/bin/sh
' H1 t# J& d% d' L6 o; ~* B7 T
: M* |) m. ~+ [; d- # [color=Red]Given a partition or mountpoint, fix it. Umount it if needed, fsck. N; w/ n# T2 _" _- ]" W
- # it, try to mount it, and if that fails reformat it and mount it
( g" h6 L. T4 p - # again. Once this function returns, we've either mounted the6 ?6 i' q3 z0 ?2 p. p4 `/ m& ]
- # partition (which may now be empty!) or we're so f*cked there's no
" }4 t) g2 U9 ~# x; E) m5 _% | - # hope of recovery.[/color]( I/ j& l: s: k% Z1 w( ]1 \; u! H
- #
! f* [# n- z$ v [ - # Pending: is it an option whether we pass -f to fsck?0 E4 B' m0 T7 Z
\- R! C( I- N* f0 t9 v- test -f /etc/default/mount_checks && . /etc/default/mount_checks
* i5 T! I0 U2 [5 V5 J - 1 i9 x/ _ G' ]& `
- echo "$0 $*" | tee /dev/console > /dev/kmsg9 M& f2 V$ w- k# _& \
- 6 R) k, H8 j; R% y) `) o" L
- usage() {
* n2 B% X3 g5 r2 k( K) O2 b - echo "usage: $0 [--force-fsck] [--force-reformat] " > /dev/console" n2 G7 _( ~ i C9 L7 m
- echo " | [--force-zero] --device </dev/something/maybe> " > /dev/console
5 v i' f. T: x0 z - echo " | --mountpoint <mountpoint>" > /dev/console
2 l/ ?# _, i. y s- P% Q+ y - exit 1& b, j7 u+ p, Z7 A
- }7 C% N/ }. s, w; ]( x
- ]3 S2 |& e8 h# Y) B" ~- reformat() {
9 |- {5 B( B) N7 z1 k - DEVICE=$1* t9 z9 J! ^+ \+ @& i( t
- . ]1 [% _# B- r$ u1 j
- # There's nothing to do if we can't umount...2 [* X z+ o5 W6 Q# Z1 I1 g! |
- grep "^${DEVICE}\s" /proc/mounts && umount $DEVICE
% @' g$ R/ {% b; [& L - 8 r- C$ H) \+ E/ b$ P
- DEV_AS_NAME=$(echo $DEVICE | tr '/' '_'); j0 |# K; u; q( A' _% l
- if [ -x /etc/fs.d/do_format${DEV_AS_NAME}.sh ]; then8 Z9 R8 [1 I; r
- /etc/fs.d/do_format${DEV_AS_NAME}.sh
- S- \1 I |1 [- {4 G1 E - mount $DEVICE 2>&1 | tee /dev/console | logger -s : ]( O& s' W9 F* p* \, b! v* c
- else2 `: U, h& j# A3 d; k3 Y+ D
- TYPE=$(grep /dev/mapper/store-update /etc/fstab | awk '{print $3}')8 T1 ~( {8 W: ?' S
- case $TYPE in
) A; r3 T) f- ~/ S, I - ext3)
& l+ r2 T5 J# q9 J; ` - [ $DEVICE = /dev/mapper/store-filecache ] && DASH_I="-I 256"4 \/ `1 E* |$ z3 q; S$ ~9 U
- mke2fs -j -b4096 -m0 $DASH_I $DEVICE
% K' c; j4 m) q& c# i; H - tune2fs -i 0 $DEVICE
4 T' u+ S- R$ Q! l1 F# E - ;;& N$ U* \% s0 b/ e4 m
- vfat)
; D0 M0 q9 U* M) A% `0 [/ M - [color=Red] mkdosfs -f 1 -s 64 $DEVICE[/color]" u# g3 A. u! s1 s
- ;;
) d5 j8 b9 d' w - *) a/ [6 h2 ?: e3 O0 l9 R" I
- echo "unable to reformat device $DEVICE of type $TYPE" | tee /dev/kmsg > /dev/console
4 X6 f0 Q l) ^# q3 Q8 K - ;;# o5 E: p4 y4 f1 i5 h
- esac
4 O+ `& c; Z- s! a( V+ O {1 h - 6 O' s6 Y9 F" |% y7 o7 J
- fi0 R. z9 U9 @4 M) y
- }1 G$ V9 p5 ?+ ~4 Y6 {
- 7 X5 X h$ U3 G& m+ l6 d
- # mount /var || fixup_partition --device /var --force-fsck
O( Z& x: T8 m. E' y - # fixup_partition --mountpoint /var --force-reformat $WIPE
/ d( |5 W& M9 C' ` - # fixup_partition --mountpoint /media/internal --force-reformat $WIPE3 y: q0 p. q: W( q( U) o& L
- # fixup_partition --mountpoint $PT --force-reformat $WIPE
' M/ K& D2 X# g& e7 q' K. Y - # MEDIA_FIX=$(fixup_partition --mountpoint /media/internal)0 c6 K, l2 b/ s) B
- , `4 O5 a) z' ~3 X2 y
- # uses:& ]0 L& ^7 X& K8 V0 V3 _
- # partition didn't mount; make it mount or reformat if necessary
6 C( l% i" J) U2 v - # reformat partition regardless of current state, optionally zeroing first
" _& O9 N# [" L) t8 c5 r l - # always return with the thing mounted1 M- Z) f, ^' } v6 t, I# z- Z
E; H1 T4 {" o, f5 H5 j/ }% g- while [ -n "$1" ]; do
& Z1 b' L/ Y h0 M4 U& d - case "$1" in% A0 C3 f5 T9 A# D' c
- --device )
G3 L& l2 K- {0 k - DEVICE="$2"
4 e& r$ R0 `1 I5 j( _ - MOUNTPT=$(grep "^${DEVICE}\s" /etc/fstab | awk '{print $2}')
% R, N% S" Q, n: { - shift 1
& p: M9 q, i) O! T* X2 L/ n3 k - ;;
5 \. L( T1 o. T: M - --mountpoint )5 l- K1 N2 b$ ^: l0 l H* h. q
- MOUNTPT="$2"
/ X' X% V( f: t1 Z, o6 R/ d - DEVICE=$(grep "\s${MOUNTPT}\s" /etc/fstab | awk '{print $1}')
9 D' e$ x) I( u" ]5 f- E" ^ - shift 1; j. b) S( @0 p% t5 ?
- ;;! I' D; H( K6 K+ G
- --force-fsck )% U4 L+ V2 i% w. O- h
- FORCE_FSCK="-f"
$ V* U4 @4 y( n" q3 d- e - ;;2 U9 f. R& O# U/ z2 C2 y# g3 k
- --force-reformat )9 T; B4 ]5 _9 y
- FORCE_REFORMAT=1
* \( ~, v& n7 j, f* r0 z4 T - ;;9 T9 k. W! B6 d/ ]2 t: `4 G+ e3 x
- --force-zero )7 Y7 p! G7 [; U& F3 w1 N w8 ^
- FORCE_REFORMAT=1 # impiled by zero, R* D9 c$ d+ J4 y
- FORCE_ZERO=1
1 k- T9 S; |( i+ I/ V - ;;
2 B& R/ f) |$ e6 L) B. C - * )
. @4 U. \5 b& Z- h) S+ E - echo "$1: unknown param" > /dev/console( b9 n" `. f! \+ S
- usage
2 a( n- g( l$ B: ]+ ^2 o2 z) G" a - ;;! u3 r/ G- ?4 [; c
- esac. d6 c$ v% M, Y6 H& b
- shift 1
' f- [. \. |, s* t - done- J9 s. j4 X% } e# {- k
- 0 U/ O. b$ D/ L) G
- if [ -z "$DEVICE" -o -z "$MOUNTPT" ]; then* g1 n/ e, E2 Z- E5 K% T( b
- echo "unable to find device or mountpoint" > /dev/console( I. S8 p. C0 p0 N# d
- usage
0 m0 {2 w- y6 w u - fi( }# d0 U; ~# v7 `
, P% H5 ]" q* T7 E5 Z* ]- # umount if mounted; not an error if not
6 Q/ S% \% m# M! s' Y+ E+ {. | - if grep -q "\s${MOUNTPT}\s" /proc/mounts; then
. t2 H) z1 n; ^+ R( v4 u. ` - # need to loop passing --force-umount flags; this must succeed.
9 f% r/ L" J7 A* k+ m9 t6 z/ { - # Would log those holding files open in this case.
, i% ^$ N9 m/ I3 Y, m - if ! umount_or_blame.sh $MOUNTPT; then
' q4 G9 }4 F9 x; N. z0 x* t) V - echo "unable to umount $DEVICE" > /dev/console& V7 a; J# W0 o
- exit 1( q6 T2 t* ]/ W
- fi
$ [, Z" _3 s! x; Q" W - fi$ F. l9 x7 J% ]# T* l' }7 r
6 }4 `$ P9 o' h8 I/ \- # no point trying to fsck if we're reformating/zeroing. Q2 O+ {1 p. I* a0 b: t1 _
- if [ -z "$FORCE_REFORMAT" ]; then: \9 T& [8 p0 l! K1 q B% G
- fsck -y $FORCE_FSCK $DEVICE 2>&1 | tee /dev/console > /dev/kmsg
P; K- J& }5 J6 M3 l0 O: P, J1 Z - WHAT_WAS_DONE="fsck"
, i! y4 d& e6 e1 T" O3 J - fi
a$ _* u5 ] v3 Z5 C- u - : V2 `! U- g& ~) J8 [+ ~
- if [ -n "$FORCE_ZERO" ]; then4 ^% t2 W1 c, S: F
- ; @ u) H, |# [, E. I2 ^( j
- # We only provide feedback for /media/internal
1 x0 z ]) E7 W( | x% { - FALLBACK=1
% y+ {3 P# A- F# H( K3 `* C$ h - if [ $MOUNTPT = $MEDIA_MOUNT ]; then
F e5 l8 \6 E; p. Y% [4 Q2 C - FALLBACK=""- v `' z* O7 G
- FEEDBACK_PIPE=/tmp/progress
. X9 z5 t9 q c$ ~' M) { - # create named pipe to send progress to fbprogress- v' R8 t9 g# ^& s* N) c" r
- grep -q '/tmp\s' /proc/mounts || mount /tmp # may not be mounted....
: L% |9 y0 R5 I3 S1 B - rm -rf $FEEDBACK_PIPE # in case it's something else
/ K9 u4 B1 K! `' a( |+ a - if ! mknod $FEEDBACK_PIPE p; then
' o' S/ J1 w' {$ n6 ?. H( N - echo "$0: mknod failed!!" | tee /dev/console > /dev/kmsg+ N# [: n! _7 [" a+ P
- FALLBACK=1
/ T" d1 x$ U$ r4 f* [ - else
/ P, C, |0 v; Y! A( D) {2 b( K. p - # fbprogress shows indeterminate progress while wiping all4 H/ ^* s$ Q& m; n% w- \" M p
- # partitions. T+ G8 i$ ]' \/ x& p! H7 c" L
- fbprogress -f erasing -p $FEEDBACK_PIPE &
! j2 g7 R% i- {$ u - FBPROGRESS_PID=$!, H- S' {6 m( w
- echo "$0: fbprogress: $FBPROGRESS_PID" | tee /dev/console > /dev/kmsg0 z$ o8 H8 i: D( j
- : z% {. w5 ^& {; x& {
- /usr/sbin/wipe_with_feedback.sh $FEEDBACK_PIPE || FALLBACK=11 F( K% f8 T" c `2 S( ^6 R
' c k- \/ y! v! W8 ~; k9 t- d- kill $FBPROGRESS_PID: i9 `1 j! W; o# y+ m" V
- rm -f $FEEDBACK_PIPE7 x# ?7 [4 I! d7 p$ W" d9 g
- fi
! C# V- ^% W& Z. I( z - fi$ O; Q1 G0 @7 J
- 5 s9 \. A- S0 f* t& g. n8 @; T
- if [ -n "$FALLBACK" ]; then( }, X. e2 G$ n, J
- dd if=/dev/zero of=$DEVICE bs=65536
2 q4 z$ c% {2 Z. B& B - fi
$ `$ i9 v7 u3 A2 f& O - fi
D( m/ B4 p% n8 v, f8 I' { - 1 T, z/ `: N. y+ } G4 I& r
- # Mount unless we're about to nuke
9 x6 s# g u9 \. i - if [ -z "$FORCE_REFORMAT" ]; then
t% D' y$ R: {% O7 X3 [+ i - mount $DEVICE 2>&1 | tee /dev/console | logger -s# _* A- b+ w/ Y. _+ l, {
- fi
# l2 u) Y9 S% S! }# B+ I, K
T+ Z3 S0 q6 v8 L& @- grep -q "\s${MOUNTPT}\s" /proc/mounts || FORCE_REFORMAT=1
2 d4 q5 S* | G# i - 0 ^4 [! Y H3 \; \0 h; ]4 ]* P
- if [ -n "$FORCE_REFORMAT" ]; then$ s' u- W7 a p
- echo "$0: reformatting $DEVICE" | tee /dev/console > /dev/kmsg
9 m/ O8 r: N* U8 L# t9 Z - reformat $DEVICE
9 n9 w* }# [; Q2 X9 ~ - WHAT_WAS_DONE="reformat"
P* Z' B* g8 D$ N& h) G - mount $DEVICE$ `, M7 g- e7 d0 n! w- G
- fi& l4 s& _. \0 q( y. N; ?" r& s
" f$ R. B8 \+ F L2 u- # "return" what we did to fix the thing
' H7 C, Q' J3 o, H6 q3 j R! v - echo "$WHAT_WAS_DONE"
5 \9 Y, V# w; w - return $?"""
复制代码 |
|